/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
package jpatp.fetch;

import javax.persistence.EntityManager;
import javax.persistence.Persistence;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Query;

import java.util.Collection;
import java.util.List;

/**
 * @author Marina Vatkina
 */
public class Client {

	private static EntityManagerFactory emf;
	private static EntityManager em;

	@SuppressWarnings("unchecked")
    public static void main(String[] args) {
		// Create EntityManagerFactory for PersistentUnit named "em1"
		emf = Persistence.createEntityManagerFactory("em1");
		em = emf.createEntityManager();

		// Begin transaction
		em.getTransaction().begin();

		// Case1: issue SQL and read all Entities
		System.out.println("<Case1>");
		Query query = em.createQuery("SELECT c FROM Customer c");
		@SuppressWarnings("unused") List<Customer> list = query.getResultList();

		//em.getTransaction().commit();
		//em.getTransaction().begin();
 
		System.out.println("<Case2>");
		Query query2 = em.createQuery("SELECT c FROM Customer c LEFT JOIN FETCH c.orders");
		//Query query2 = em.createQuery("SELECT c FROM Customer c");
		List<Customer> list2 = query2.getResultList();
		for(Customer c: list2){
			System.out.println("ID:" + c.getId());
			Collection<Order> collection = c.getOrders();
			for(Order o: collection){
				System.out.println("Address:" + o.getAddress());
			}
		}

		em.getTransaction().commit();
		em.close();

	}


	private static void createTransactionalEntityManager() {

		// Create a new EntityManager
		em = emf.createEntityManager();

		// Begin transaction
		em.getTransaction().begin();

	}

	private static void closeTransactionalEntityManager() {

	    // Commit the transaction
	    em.getTransaction().commit();

	    // Close this EntityManager
	    em.close();

	}

    private static void createEntityManager() {

        // Create a new EntityManager
        em = emf.createEntityManager();
    }

    private static void closeEntityManager() {

        // Close this EntityManager
        em.close();
    }

}
